searchNodes=[{"doc":"A struct representing the quality score of a FASTQ file. % QualityScore { scoring_characters : binary ( ) , scores : [ integer ( ) ] , label : binary ( ) , encoding : Bio.IO.FastQ . quality_encoding ( ) }","ref":"Bio.QualityScore.html","title":"Bio.QualityScore","type":"module"},{"doc":"Bio.Random.Dna will generate random sequences of DNA based on the given arguments: seed - RNG seed (defaults to RNG default seeding) algorithm - RNG algorithm (defaults to exsss) seq-count - integer number of sequences to generate (required) seq-size - integer size of sequence to generate (required) outfile - output filename or path (required)","ref":"Mix.Tasks.Bio.Random.Dna.html","title":"Mix.Tasks.Bio.Random.Dna","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Bio.Random.Dna.html#run/1","title":"Mix.Tasks.Bio.Random.Dna.run/1","type":"function"},{"doc":"Module for building out the actual data structure that will be generated in code. Each enzyme will be defined as a struct under the Bio.Restriction.Enzyme namespace. This struct will be populated with the minimal data needed for the use in digestion and sequence validations. Further additions to the data can be requested by opening an issue. The current data preserved are: blunt?: boolean cut_1: number cut_2: number cut_3: number cut_4: number name: string pattern: string","ref":"Mix.Tasks.Bio.Restriction.Build.html","title":"Mix.Tasks.Bio.Restriction.Build","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Bio.Restriction.Build.html#run/1","title":"Mix.Tasks.Bio.Restriction.Build.run/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Bio.Restriction.Build.html#sourcify/1","title":"Mix.Tasks.Bio.Restriction.Build.sourcify/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Bio.Restriction.Build.html#stringify/1","title":"Mix.Tasks.Bio.Restriction.Build.stringify/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Bio.Restriction.Build.html#to_source/1","title":"Mix.Tasks.Bio.Restriction.Build.to_source/1","type":"function"},{"doc":"This runs a series of downloads to get the relevant files from REBASE These are used to generate the restriction enzyme data. Requires your email and a directory as the only arguments. The email is used for the download of the data through FTP from REBASE. The directory is where the files should be downloaded to.","ref":"Mix.Tasks.Bio.Restriction.Download.html","title":"Mix.Tasks.Bio.Restriction.Download","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Bio.Restriction.Download.html#run/1","title":"Mix.Tasks.Bio.Restriction.Download.run/1","type":"function"},{"doc":"Update the library of restriction enzymes according to REBASE data.","ref":"Mix.Tasks.Bio.Restriction.Update.html","title":"Mix.Tasks.Bio.Restriction.Update","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Bio.Restriction.Update.html#run/1","title":"Mix.Tasks.Bio.Restriction.Update.run/1","type":"function"},{"doc":"Allow the input of FASTQ formatted files. This implementation references the documentation from NCBI and uses the Phred scoring 33 offset by default when reading quality scores.","ref":"Bio.IO.FastQ.html","title":"Bio.IO.FastQ","type":"module"},{"doc":"Read a FASTQ formatted file into memory The read/2 function returns an error tuple of the content or error code from File.read . You can use :file.format_error/1 to get a descriptive string of the error. Content is returned as a list of tuples where the first element is a struct of the type from the type option, and the second element is a Bio.QualityScore . Options type - The module for the Sequence type that you want the returned value in. Defaults to Bio.Sequence.DnaStrand . Module should implement the Bio.Sequential behaviour. quality_encoding - Determines the encoding of the quality scores.","ref":"Bio.IO.FastQ.html#read/2","title":"Bio.IO.FastQ.read/2","type":"function"},{"doc":"Read a FASTQ formatted file The same as read/2 , but will raise a File.Error on failure.","ref":"Bio.IO.FastQ.html#read!/2","title":"Bio.IO.FastQ.read!/2","type":"function"},{"doc":"","ref":"Bio.IO.FastQ.html#t:quality_encoding/0","title":"Bio.IO.FastQ.quality_encoding/0","type":"type"},{"doc":"","ref":"Bio.IO.FastQ.html#t:read_opts/0","title":"Bio.IO.FastQ.read_opts/0","type":"type"},{"doc":"Allow the input/output of FASTA formatted files. The FASTA file format is composed of pairs of lines where the pair is demarcated by the &quot;&gt;&quot; character. All data proceeding the &quot;&gt;&quot; character represents the 'header' of the pair, while the next line after a newline represents sequence data. Any data after subsequent newlines that are not preceded by a second &quot;&gt;&quot; character are assumed to be multi-line data. For example, the following two files would be considered equivalent data: # fasta 1 &gt; header1 atgcatgca and # fasta 2 &gt; header1 atgc atgca The FASTA file format does not specify the type of the data in the sequence. That means that you can reasonably store RNA, DNA, amino acid, or any other sequence using the format. In general, the expectation is that the data is ASCII encoded. The methods in this module do support reading into specified types. See read/2 for more details.","ref":"Bio.IO.Fasta.html","title":"Bio.IO.Fasta","type":"module"},{"doc":"Read a FASTA formatted file The read/2 function returns an error tuple of the content or error code from File.read . You can use :file.format_error/1 to get a descriptive string of the error. You can specify the return type of the contents by using a module which implements the Bio.Sequential behaviour. Specifically the type must have a new/2 method. Options :type - The module for the type of struct you wish to have returned. This should minimally implement a new/2 function equivalent to the Bio.Sequential behaviour. Otherwise the base Bio.Sequence is used. :parse_header - A callable for parsing the header values of the FASTA file. Otherwise identity is used and the header is returned as is.","ref":"Bio.IO.Fasta.html#read/2","title":"Bio.IO.Fasta.read/2","type":"function"},{"doc":"Read a FASTA formatted file The same as read/2 , but will raise a File.Error on failure.","ref":"Bio.IO.Fasta.html#read!/2","title":"Bio.IO.Fasta.read!/2","type":"function"},{"doc":"Write a FASTA file using sequence data. The data type that this function accepts is varied, and may be one of a number of List s. Examples of which types are handled: List: # a list of header/sequence tuples [ { header ( ) , sequence ( ) } , ... ] # a list of header/sequence implicitly paired [ header ( ) , sequence ( ) , header ( ) , sequence ( ) , ... ] # a list of struct() [ % Bio.Sequence . _ { } , ... ] Where %Bio.Sequence._{} indicates any struct of the Bio.Sequence module or modules implementing the Bio.Sequential behaviour. It also supports data in a Map format: %{ headers : [ header ( ) , ... ] , sequences : [ sequence ( ) , ... ] } Examples iex&gt; Fasta . write ( &quot;/tmp/test_file.fasta&quot; , [ &quot;header&quot; , &quot;sequence&quot; , &quot;header2&quot; , &quot;sequence2&quot; ] ) :ok Will return error types in common with File.write/3","ref":"Bio.IO.Fasta.html#write/3","title":"Bio.IO.Fasta.write/3","type":"function"},{"doc":"","ref":"Bio.IO.Fasta.html#t:fasta_data/0","title":"Bio.IO.Fasta.fasta_data/0","type":"type"},{"doc":"","ref":"Bio.IO.Fasta.html#t:header/0","title":"Bio.IO.Fasta.header/0","type":"type"},{"doc":"","ref":"Bio.IO.Fasta.html#t:read_opts/0","title":"Bio.IO.Fasta.read_opts/0","type":"type"},{"doc":"","ref":"Bio.IO.Fasta.html#t:sequence/0","title":"Bio.IO.Fasta.sequence/0","type":"type"},{"doc":"Read a SnapGene file The file is read into a struct with the following fields: % Bio.IO.SnapGene { sequence : % Bio.Sequence.DnaStrand { } , circular? : boolean ( ) , valid? : boolean ( ) , features : tuple ( ) } The circular? and sequence fields are parsed from the DNA packet. The sequence field is represented by default as a Bio.Sequence.DnaStrand , but any module that behaves as a Bio.Behaviours.Sequence can be used, since the new/2 method is applied to create the struct. Error No validation is applied to the sequence, so you can force an invalid sequence struct by passing a module for the incorrect sequence. The valid? property is determined by parsing the SnapGene cookie to ensure that it contains the requisite &quot;SnapGene&quot; string. Note The concept of validity has to do with the snap gene file, and not the sequence or any other of the parsed data. Features require a bit more explanation, since they are stored in XML. Parsing them into a map is certainly a possibility, but it seemed like doing so would reduce the ability of a developer to leverage what I am hoping is a lower level library than some. In the interest of leaving the end user with as much power as possible, this method does not attempt to parse the XML stored within the file. Instead, the XML is returned to you in the form generated by :xmerl_scan.string/1 . In doing it this way you have access to the entire space of data stored within the file, not just a subset that is parsed. This also means that in order to query the data, you need to be comfortable composing XPaths. As an example, if you have a terminator feature as the first feature and you want to get the segment range: iex&gt; { :ok , sample } = SnapGene . read ( &quot;test/io/snap_gene/sample-e.dna&quot; ) ...&gt; :xmerl_xpath . string ( &#39;string(/*/Feature[1]/Segment/@range)&#39; , sample . features ) { :xmlObj , :string , &#39;400-750&#39; } As another note, this will also require some familiarity with the file type, for example whether or not a range is exclusive or inclusive on either end. Attempting to access a node that doesn't exist will return an empty array. iex&gt; { :ok , sample } = SnapGene . read ( &quot;test/io/snap_gene/sample-e.dna&quot; ) ...&gt; :xmerl_xpath . string ( &#39;string(/*/Feature[1]/Unknown/Path/@range)&#39; , sample . features ) { :xmlObj , :string , [ ] } The semantics of this are admittedly odd. But there's not much to be done about that. The object returned from :xmerl_xpath.string/[2,3,4] is a tuple, so Enumerable isn't implemented for it. You're best off sticking to XPath to get the required elements. The counts of things are simple enough to retrieve in this way though. For example, if I wanted to know how many Feature Segments there were: iex&gt; { :ok , sample } = SnapGene . read ( &quot;test/io/snap_gene/sample-e.dna&quot; ) ...&gt; :xmerl_xpath . string ( &#39;count(/*/Feature/Segment)&#39; , sample . features ) { :xmlObj , :number , 2 } Now it's a simple matter to map over the desired queries to build up some data from the XML: iex&gt; { :ok , sample } = SnapGene . read ( &quot;test/io/snap_gene/sample-e.dna&quot; ) ...&gt; Enum . map ( 1 .. 2 , fn i -&gt; :xmerl_xpath . string ( &#39;string(/*/Feature[ \#{ i } ]/Segment/@range)&#39; , sample . features ) end ) [ { :xmlObj , :string , &#39;400-750&#39; } , { :xmlObj , :string , &#39;161-241&#39; } ] I cover the basics of using XPath to perform queries in the Using XML guide. I also plan to write a follow up guide with further examples of queries, and an explanation of the mapping of concepts between the XML and what is parsed from BioPython.","ref":"Bio.IO.SnapGene.html","title":"Bio.IO.SnapGene","type":"module"},{"doc":"Read the contents of a SnapGene file. Takes a filename and reads the contents into the %Bio.IO.SnapGene{} struct. Returns an error tuple on failure with the cause from File.read/1 . You can use :file.format_error/1 to get a descriptive string of the error.","ref":"Bio.IO.SnapGene.html#read/2","title":"Bio.IO.SnapGene.read/2","type":"function"},{"doc":"Implementations of the basic sequence functionality. Calling use Bio.BaseSequence will generate a simple struct in the calling module, as well as the implementation for the Enumerable protocol. Because the Enum module makes certain assumptions about the data that it is given, we cannot trust that the functions therein will always behave how it makes the most sense. As an example, there is no way to ensure that Enum.slide/3 returns anything other than a list. I believe that it makes sense for it to return the enumerable type, so you would get e.g. a Bio.Sequence.DnaStrand back. With that said, many of the Enum module's functions shouldn't make assumptions. This is largely idiosynctratic, and so instead of trying to ham-fist the Enum functions to work, I just wrapped them up with Bio.Enum . The implementations in Bio.Enum rely on the Enum functions to work, but they go the extra mile in terms of returning things that seem to make the most sense. See the documentation of Bio.Enum for more on that. This module will also cause new/2 to be defined. This function takes a sequence as well as the keywords :label and :length . For more examples of using new/2 see Bio.Sequence.AminoAcid , Bio.Sequence.DnaStrand , or Bio.Sequence.RnaStrand .","ref":"Bio.BaseSequence.html","title":"Bio.BaseSequence","type":"module"},{"doc":"Deals with conversions between polymers. The sequences that this will work with must define an implementation for the Bio.Polymeric protocol. This is then used with the definition of the to/1 callbacks for the Bio.Convertible behaviour. These will be given the kmer enumeration that they define with that function. This module wraps the logic of accessing a given polymer's defined conversions. The primary idea is that I wanted to expose the ability to provide a non-default conversion without losing the semantics of a simple default when it's present. To put that in more concrete terms, I wanted this to be viable: iex&gt; dna = DnaStrand . new ( &quot;ttagccgt&quot; , label : &quot;a label&quot; ) ...&gt; Bio.Polymer . convert ( dna , RnaStrand ) { :ok , % RnaStrand { sequence : &quot;uuagccgu&quot; , length : 8 , label : &quot;a label&quot; } } But, and this is the important part, other conversions are not well defined by defaults. For example: iex&gt; amino = AminoAcid . new ( &quot;maktg&quot; ) ...&gt; Bio.Polymer . convert ( amino , DnaStrand ) { :error , :undef_conversion } The :undef_conversion indicates that there is no viable default implementation of the conversion between these polymers. It does not indicate that there is none. Obviously one can convert from an amino acid to some DNA strand. However, because this would imply making a selection from the available codons, that is left to the logic of whatever application is doing so. The way that you would do that is straight forward, you would define a conversion module and pass it to the convert/3 function as the keyword argument :conversion . For example, if we wanted to defined a mapping that converted into a compressed DNA representation, we could do: iex&gt; defmodule CompressedAminoConversion do ...&gt; use Bio.Convertible do ...&gt; def to ( DnaStrand ) , do : { :ok , &amp; compressed / 2 , 1 } ...&gt; end ...&gt; ...&gt; def compressed ( { :ok , knumerable , data } , _ ) do ...&gt; data = data ...&gt; |&gt; Map . drop ( [ :length ] ) ...&gt; |&gt; Map . to_list ( ) ...&gt; knumerable ...&gt; |&gt; Enum . map ( &amp; to_codon / 1 ) ...&gt; |&gt; Enum . join ( &quot;&quot; ) ...&gt; |&gt; DnaStrand . new ( data ) ...&gt; end ...&gt; ...&gt; defp to_codon ( aa ) do ...&gt; case aa do ...&gt; &quot;a&quot; -&gt; &quot;gcn&quot; ...&gt; &quot;r&quot; -&gt; &quot;cgn&quot; ...&gt; &quot;n&quot; -&gt; &quot;aay&quot; ...&gt; &quot;d&quot; -&gt; &quot;gay&quot; ...&gt; &quot;c&quot; -&gt; &quot;tgy&quot; ...&gt; &quot;e&quot; -&gt; &quot;gar&quot; ...&gt; &quot;q&quot; -&gt; &quot;car&quot; ...&gt; &quot;g&quot; -&gt; &quot;ggn&quot; ...&gt; &quot;h&quot; -&gt; &quot;cay&quot; ...&gt; &quot;i&quot; -&gt; &quot;ath&quot; ...&gt; &quot;l&quot; -&gt; &quot;ctn&quot; ...&gt; &quot;k&quot; -&gt; &quot;aar&quot; ...&gt; &quot;m&quot; -&gt; &quot;atg&quot; ...&gt; &quot;f&quot; -&gt; &quot;tty&quot; ...&gt; &quot;p&quot; -&gt; &quot;ccn&quot; ...&gt; &quot;s&quot; -&gt; &quot;tcn&quot; ...&gt; &quot;t&quot; -&gt; &quot;acn&quot; ...&gt; &quot;w&quot; -&gt; &quot;tgg&quot; ...&gt; &quot;y&quot; -&gt; &quot;tay&quot; ...&gt; &quot;v&quot; -&gt; &quot;gtn&quot; ...&gt; end ...&gt; end ...&gt; end ...&gt; amino = AminoAcid . new ( &quot;maktg&quot; , label : &quot;polypeptide-∂&quot; ) ...&gt; Bio.Polymer . convert ( amino , DnaStrand , conversion : CompressedAminoConversion ) { :ok , % DnaStrand { sequence : &quot;atggcnaaracnggn&quot; , length : 15 , label : &quot;polypeptide-∂&quot; } } This is made possible because of the simple implementation of the Bio.Polymeric interface for the Bio.Sequence.AminoAcid . If you want to define your own convertible polymer types, you can. It requires defining the module and the implementation of convert/1 . You can read the Bio.Sequence.AminoAcid source for more clarity on the details. This package attempts to define reasonable defaults for all the occasions which it can. This includes converting DNA into RNA, and RNA to DNA. The conversions from DNA/RNA to Amino Acid are done using standard codon tables. The Conversion module idea is provided as an escape hatch for more particular applications which may require bespoke logic. An example would be converting Amino Acids into a DNA sequence, as above. There are likely more use cases than I could possibly compile on my own, so I tried to come up with a way to alleviate that pressure.","ref":"Bio.Polymer.html","title":"Bio.Polymer","type":"module"},{"doc":"Apply a conversion to a given datum. The convert/3 function is at the core of using the Bio.Polymer module. By passing the function a struct and the module you wish to convert to, you are hooking into the underlying implementation of the Bio.Convertible for that module. This means that both the struct you given as well as the module must have this implemented. Examples Given a struct and module with a known conversion: iex&gt; dna = DnaStrand . new ( &quot;ttagccgt&quot; , label : &quot;a label&quot; ) ...&gt; Bio.Polymer . convert ( dna , RnaStrand ) { :ok , % RnaStrand { sequence : &quot;uuagccgu&quot; , length : 8 , label : &quot;a label&quot; } } Given a struct and module with unknown conversions: iex&gt; amino = AminoAcid . new ( &quot;maktg&quot; ) ...&gt; Bio.Polymer . convert ( amino , DnaStrand ) { :error , :undef_conversion } Given a struct that doesn't implement Bio.Sequential : iex&gt; amino = Bio.QualityScore . new ( &quot;maktg&quot; , encoding : :phred_33 ) ...&gt; Bio.Polymer . convert ( amino , DnaStrand ) { :error , :no_converter }","ref":"Bio.Polymer.html#convert/3","title":"Bio.Polymer.convert/3","type":"function"},{"doc":"","ref":"Bio.Polymer.html#valid?/2","title":"Bio.Polymer.valid?/2","type":"function"},{"doc":"Validate a given sequence struct according to its Bio.Polymeric implementation.","ref":"Bio.Polymer.html#validate/2","title":"Bio.Polymer.validate/2","type":"function"},{"doc":"Bio.Sequence is the basic building block of the sequence types. The core concept here is that a polymer is a sequence of elements encoded as a binary. This is stored in the base %Bio.Sequence{} struct, which has both a sequence and length field, and may carry a label and alphabet field as well. The struct is intentionally sparse on information since this is meant to compose into larger data types. For example, the Bio.Sequence.DnaDoubleStrand struct, which has two polymer Bio.Sequence.DnaStrand s as the top_strand and bottom_strand fields. Because many of the sequence behaviors are shared, they are implemented by Bio.BaseSequence and used in the modules that need them. This allows us to ensure that there is a consistent implementation of the Enumerable protocol, which in turn allows for common interaction patterns a la Python strings: iex&gt; &quot;gmc&quot; in Bio.Sequence . new ( &quot;agmctbo&quot; ) true iex&gt; Bio.Sequence . new ( &quot;agmctbo&quot; ) ...&gt; |&gt; Enum . map ( &amp; ( &amp;1 ) ) [ &quot;a&quot; , &quot;g&quot; , &quot;m&quot; , &quot;c&quot; , &quot;t&quot; , &quot;b&quot; , &quot;o&quot; ] My hope is that this alleviates some of the pain of coming from a language where strings are slightly more complex objects. Additionally, you should look at the Bio.Enum module for dealing with cases where the Enum default implementation results in odd behavior. It also implements certain behaviors like returning the same type for functions: iex&gt; Bio.Sequence . new ( &quot;agmctbo&quot; ) ...&gt; |&gt; Enum . slice ( 2 , 2 ) &#39;mc&#39; vs iex&gt; alias Bio.Enum , as : Bnum ...&gt; Bio.Sequence . new ( &quot;agmctbo&quot; ) ...&gt; |&gt; Bnum . slice ( 2 , 2 ) % Bio.Sequence { sequence : &quot;mc&quot; , length : 2 }","ref":"Bio.Sequence.html","title":"Bio.Sequence","type":"module"},{"doc":"Get the full name for a given monomer. Example iex&gt; MonomerName . nucleic_acid ( &quot;a&quot; ) &quot;adenine&quot; iex&gt; MonomerName . amino_acid ( &quot;a&quot; ) &quot;alanine&quot;","ref":"Bio.Sequence.MonomerName.html","title":"Bio.Sequence.MonomerName","type":"module"},{"doc":"Mapping amino acids to their chemical names Example iex&gt; MonomerName . nucleic_acid ( &quot;a&quot; ) &quot;adenine&quot;","ref":"Bio.Sequence.MonomerName.html#amino_acid/1","title":"Bio.Sequence.MonomerName.amino_acid/1","type":"function"},{"doc":"Mapping nucleotides to their chemical names Example iex&gt; MonomerName . nucleic_acid ( &quot;a&quot; ) &quot;adenine&quot;","ref":"Bio.Sequence.MonomerName.html#nucleic_acid/1","title":"Bio.Sequence.MonomerName.nucleic_acid/1","type":"function"},{"doc":"A module for working with DNA. This module doesn't contain a representative struct, as with Bio.Sequence.Rna . This is because there are multiple ways to interpret a string as DNA. Namely, it can either be single or double stranded. This is why the Bio.Sequence.DnaStrand and Bio.Sequence.DnaDoubleStrand modules exist. However, this is the interface for dealing with things like complement/1 and reverse_complement!/1 . Additionally, this module handles defining default conversions for the DNA sequence types into RNA sequence types ( Bio.Sequence.RnaStrand and Bio.Sequence.RnaDoubleStrand ). Conversions defined here are used by the Bio.Sequence.DnaStrand and Bio.Sequence.DnaDoubleStrand modules. The default conversions use conventional nucleotides and map them to their relevant RNA nucleotides: a -&gt; a t -&gt; u g -&gt; g c -&gt; c Casing is preserved, so mixed case sequences will not be altered. Example iex&gt; DnaStrand . new ( &quot;taTTg&quot; ) ...&gt; |&gt; Bio.Polymer . convert ( RnaStrand ) { :ok , % RnaStrand { sequence : &quot;uaUUg&quot; , length : 5 } } This is guaranteed, so you may encode these with intention and assume that they are preserved across conversions.","ref":"Bio.Sequence.Dna.html","title":"Bio.Sequence.Dna","type":"module"},{"doc":"Provide the DNA complement to a sequence. Given a sequence that is either a binary or a Bio.Sequence.DnaStrand , returns the DNA complement as defined by the standard nucleotide complements. Examples iex&gt; Dna . complement ( &quot;attgacgt&quot; ) { :ok , &quot;taactgca&quot; } iex&gt; DnaStrand . new ( &quot;attgacgt&quot; ) ...&gt; |&gt; Dna . complement ( ) { :ok , % DnaStrand { sequence : &quot;taactgca&quot; , length : 8 , alphabet : Bio.Sequence.Alphabets.Dna . common ( ) } }","ref":"Bio.Sequence.Dna.html#complement/2","title":"Bio.Sequence.Dna.complement/2","type":"function"},{"doc":"Provide the DNA reverse complement to a sequence. Given a sequence that is either a binary or a Bio.Sequence.DnaStrand , returns the DNA reverse complement as defined by the standard nucleotide complements. Examples iex&gt; Dna . reverse_complement! ( &quot;attgacgt&quot; ) &quot;acgtcaat&quot; iex&gt; DnaStrand . new ( &quot;attgacgt&quot; ) ...&gt; |&gt; Dna . reverse_complement! ( ) % DnaStrand { sequence : &quot;acgtcaat&quot; , length : 8 }","ref":"Bio.Sequence.Dna.html#reverse_complement!/2","title":"Bio.Sequence.Dna.reverse_complement!/2","type":"function"},{"doc":"","ref":"Bio.Sequence.Dna.html#t:complementable/0","title":"Bio.Sequence.Dna.complementable/0","type":"type"},{"doc":"","ref":"Bio.Sequence.Dna.html#t:msg/0","title":"Bio.Sequence.Dna.msg/0","type":"type"},{"doc":"A representative struct for Double Stranded DNA polymers.","ref":"Bio.Sequence.DnaDoubleStrand.html","title":"Bio.Sequence.DnaDoubleStrand","type":"module"},{"doc":"Generate a new %Bio.Sequence.DnaDoubleStrand{} struct. Options label - This is a label applied to the top and bottom. alphabet - This is the alphabet to use for the top and bottom strands, defaults to the Bio.Sequence.Alphabets.Dna.iupac/0 . This allows the most general use of the new function in unknown scenarios. complement_offset - Offset for the strands. Positive values are considered offset to top, negative as offset to bottom. E.g. 5 would give 5 nt offset on top, leading to a bottom strand overhand on the 5' side and a top strand overhang on the 3' side.","ref":"Bio.Sequence.DnaDoubleStrand.html#new/2","title":"Bio.Sequence.DnaDoubleStrand.new/2","type":"function"},{"doc":"A single DNA strand can be represented by the basic sequence which uses Bio.BaseSequence . Examples iex&gt; &quot;tagc&quot; in DnaStrand . new ( &quot;ttagct&quot; ) true iex&gt; alias Bio.Enum , as : Bnum ...&gt; DnaStrand . new ( &quot;ttagct&quot; ) ...&gt; |&gt; Bnum . map ( &amp; ( &amp;1 ) ) % DnaStrand { sequence : &quot;ttagct&quot; , length : 6 } iex&gt; alias Bio.Enum , as : Bnum ...&gt; DnaStrand . new ( &quot;ttagct&quot; ) ...&gt; |&gt; Bnum . slice ( 2 , 2 ) % DnaStrand { sequence : &quot;ag&quot; , length : 2 }","ref":"Bio.Sequence.DnaStrand.html","title":"Bio.Sequence.DnaStrand","type":"module"},{"doc":"A module for working with RNA. This module doesn't contain a representative struct, as with Bio.Sequence.Dna . This is because there are multiple ways to interpret a string as RNA. Namely, it can either be single or double stranded. This is why the Bio.Sequence.RnaStrand and Bio.Sequence.RnaDoubleStrand modules exist. However, this is the interface for dealing with things like complement/1 and reverse_complement/1 . Additionally, this module handles defining default conversions for the DNA sequence types into RNA sequence types ( Bio.Sequence.DnaStrand and Bio.Sequence.DnaDoubleStrand ). Conversions defined here are used by the Bio.Sequence.RnaStrand and Bio.Sequence.RnaDoubleStrand modules. The default conversions use conventional nucleotides and map them to their relevant DNA nucleotides: a -&gt; a u -&gt; t g -&gt; g c -&gt; c Casing is preserved, so mixed case sequences will not be altered. Example iex&gt; RnaStrand . new ( &quot;uaUUg&quot; ) ...&gt; |&gt; Bio.Polymer . convert ( DnaStrand ) { :ok , % DnaStrand { sequence : &quot;taTTg&quot; , length : 5 } } This is guaranteed, so you may encode these with intention and assume that they are preserved across conversions.","ref":"Bio.Sequence.Rna.html","title":"Bio.Sequence.Rna","type":"module"},{"doc":"Provide the RNA complement to a sequence. Given a sequence that is either a binary or a Bio.Sequence.RnaStrand , returns the RNA complement as defined by the standard nucleotide complements. Examples iex&gt; Rna . complement ( &quot;auugacgu&quot; ) { :ok , &quot;uaacugca&quot; } iex&gt; RnaStrand . new ( &quot;auugacgu&quot; ) ...&gt; |&gt; Rna . complement ( ) { :ok , % RnaStrand { sequence : &quot;uaacugca&quot; , length : 8 , alphabet : Alpha . common ( ) } }","ref":"Bio.Sequence.Rna.html#complement/2","title":"Bio.Sequence.Rna.complement/2","type":"function"},{"doc":"Provide the RNA reverse complement to a sequence. Given a sequence that is either a binary or a Bio.Sequence.RnaStrand , returns the RNA reverse complement as defined by the standard nucleotide complements. Examples iex&gt; Rna . reverse_complement ( &quot;auugacgu&quot; ) &quot;acgucaau&quot; iex&gt; RnaStrand . new ( &quot;auugacgu&quot; ) ...&gt; |&gt; Rna . reverse_complement ( ) % RnaStrand { sequence : &quot;acgucaau&quot; , length : 8 }","ref":"Bio.Sequence.Rna.html#reverse_complement/1","title":"Bio.Sequence.Rna.reverse_complement/1","type":"function"},{"doc":"","ref":"Bio.Sequence.Rna.html#t:complementable/0","title":"Bio.Sequence.Rna.complementable/0","type":"type"},{"doc":"","ref":"Bio.Sequence.RnaDoubleStrand.html","title":"Bio.Sequence.RnaDoubleStrand","type":"module"},{"doc":"A single RNA strand can be represented by the basic sequence which implements the Bio.Polymer behavior. This module doesn't implement any validations, since those are not well defined in every case. For example, it may be valid to contain ambiguous nucleotides, or it may not. Since that depends on the use, this is left to applications developers to write. Examples iex&gt; &quot;uagc&quot; in RnaStrand . new ( &quot;uuagcu&quot; ) true iex&gt; alias Bio.Enum , as : Bnum ...&gt; RnaStrand . new ( &quot;uuagcu&quot; ) ...&gt; |&gt; Bnum . map ( &amp; ( &amp;1 ) ) % RnaStrand { sequence : &quot;uuagcu&quot; , length : 6 } iex&gt; alias Bio.Enum , as : Bnum ...&gt; RnaStrand . new ( &quot;uuagcu&quot; ) ...&gt; |&gt; Bnum . slice ( 2 , 2 ) % RnaStrand { sequence : &quot;ag&quot; , length : 2 }","ref":"Bio.Sequence.RnaStrand.html","title":"Bio.Sequence.RnaStrand","type":"module"},{"doc":"Amino acids are modeled as simple sequences using Bio.BaseSequence . Examples iex&gt; aa = AminoAcid . new ( &quot;ymabagta&quot; ) ...&gt; &quot;mabag&quot; in aa true iex&gt; alias Bio.Enum , as : Bnum ...&gt; AminoAcid . new ( &quot;ymabagta&quot; ) ...&gt; |&gt; Bnum . map ( &amp; ( &amp;1 ) ) % AminoAcid { sequence : &quot;ymabagta&quot; , length : 8 } iex&gt; alias Bio.Enum , as : Bnum ...&gt; AminoAcid . new ( &quot;ymabagta&quot; ) ...&gt; |&gt; Bnum . slice ( 2 , 2 ) % AminoAcid { sequence : &quot;ab&quot; , length : 2 } If you are interested in defining conversions of amino acids then look into the Bio.Polymer module for how to deal with creating a Conversion module. The simple Bio.Sequence.AminoAcid does define the Bio.Polymeric protocol, which will allow you to define conversions from this to any type you may desire.","ref":"Bio.Sequence.AminoAcid.html","title":"Bio.Sequence.AminoAcid","type":"module"},{"doc":"Alphabets relevant to the sequences, coding schemes are expressed in essentially BNF . Values and interpretations for the scheme were accessed from here . Also exposes the complementary elements for DNA/RNA allowing strands to be complemented. These functions shouldn't be used directly, but look at Bio.Sequence.Dna.complement/2 and Bio.Sequence.Rna.complement/1 for more information. Alphabets may be used in the declaration of Bio.BaseSequence structs to define how they should be validated. In case one is not supplied, a default may be preferred. See Bio.Sequence.Dna , Bio.Sequence.Rna , Bio.Sequence.AminoAcid , and Bio.Polymer.valid?/2 for more information. Bio.Sequence.Dna The DNA alphabets provided are: common - The standard bases ATGCatgc with_n - The standard alphabet, but with the ambiguous &quot;any&quot; character Nn iupac - The IUPAC standard values ACGTRYSWKMBDHVNacgtryswkmbdhvn Bio.Sequence.Rna common - The standard bases ACGUacgu with_n - The standard alphabet, but with the ambiguous &quot;any&quot; character Nn iupac - The IUPAC standard values ACGURYSWKMBDHVNacguryswkmbdhvn Bio.Sequence.AminoAcid common - The standad 20 amino acid codes ARNDCEQGHILKMFPSTWYVarndceqghilkmfpstwyv iupac - ABCDEFGHJIKLMNPQRSTVWXYZabcdefghjiklmnpqrstvwxyz Coding Schemes Deoxyribonucleic Acid codes A :: = Adenine C :: = Cytosine G :: = Guanine T :: = Thymine R :: = A | G Y :: = C | T S :: = G | C W :: = A | T K :: = G | T M :: = A | C B :: = S | T ( ¬ A ) D :: = R | T ( ¬ C ) H :: = M | T ( ¬ G ) V :: = M | G ( ¬ T ) N :: = ANY Ribonucleic Acid codes A :: = Adenine C :: = Cytosine G :: = Guanine U :: = Uracil R :: = A | G Y :: = C | U S :: = G | C W :: = A | U K :: = G | U M :: = A | C B :: = S | U ( ¬ A ) D :: = R | U ( ¬ C ) H :: = M | U ( ¬ G ) V :: = M | G ( ¬ U ) N :: = ANY Amino Acid codes A :: = Alanine C :: = Cysteine D :: = Aspartic Acid E :: = Glutamic Acid F :: = Phenylalanine G :: = Glycine H :: = Histidine I :: = Isoleucine K :: = Lysine L :: = Leucine M :: = Methionine N :: = Asparagine P :: = Proline Q :: = Glutamine R :: = Arginine S :: = Serine T :: = Threonine V :: = Valine W :: = Tryptophan Y :: = Tyrosine B :: = D | N Z :: = Q | E J :: = I | L X :: = ANY","ref":"Bio.Sequence.Alphabets.html","title":"Bio.Sequence.Alphabets","type":"module"},{"doc":"Amino Acid Alphabets","ref":"Bio.Sequence.Alphabets.AminoAcid.html","title":"Bio.Sequence.Alphabets.AminoAcid","type":"module"},{"doc":"ARNDCEQGHILKMFPSTWYVarndceqghilkmfpstwyv","ref":"Bio.Sequence.Alphabets.AminoAcid.html#common/0","title":"Bio.Sequence.Alphabets.AminoAcid.common/0","type":"function"},{"doc":"ABCDEFGHJIKLMNPQRSTVWXYZabcdefghJiklmnpqrstvwxyz","ref":"Bio.Sequence.Alphabets.AminoAcid.html#iupac/0","title":"Bio.Sequence.Alphabets.AminoAcid.iupac/0","type":"function"},{"doc":"DNA Alphabets","ref":"Bio.Sequence.Alphabets.Dna.html","title":"Bio.Sequence.Alphabets.Dna","type":"module"},{"doc":"ATGCatgc","ref":"Bio.Sequence.Alphabets.Dna.html#common/0","title":"Bio.Sequence.Alphabets.Dna.common/0","type":"function"},{"doc":"Complements a given character according to the supplied alphabet. Alphabet must be one of the valid Bio.Sequence.Alphabets.Dna options.","ref":"Bio.Sequence.Alphabets.Dna.html#complement/2","title":"Bio.Sequence.Alphabets.Dna.complement/2","type":"function"},{"doc":"ACGTRYSWKMBDHVNacgtryswkmbdhvn","ref":"Bio.Sequence.Alphabets.Dna.html#iupac/0","title":"Bio.Sequence.Alphabets.Dna.iupac/0","type":"function"},{"doc":"ACGTNacgtn","ref":"Bio.Sequence.Alphabets.Dna.html#with_n/0","title":"Bio.Sequence.Alphabets.Dna.with_n/0","type":"function"},{"doc":"RNA Alphabets","ref":"Bio.Sequence.Alphabets.Rna.html","title":"Bio.Sequence.Alphabets.Rna","type":"module"},{"doc":"ACGUacgu","ref":"Bio.Sequence.Alphabets.Rna.html#common/0","title":"Bio.Sequence.Alphabets.Rna.common/0","type":"function"},{"doc":"Complements a given character according to the supplied alphabet. Alphabet must be one of the valid Bio.Sequence.Alphabets.Rna options.","ref":"Bio.Sequence.Alphabets.Rna.html#complement/2","title":"Bio.Sequence.Alphabets.Rna.complement/2","type":"function"},{"doc":"ACGURYSWKMBDHVNZacguryswkmbdhvnz","ref":"Bio.Sequence.Alphabets.Rna.html#iupac/0","title":"Bio.Sequence.Alphabets.Rna.iupac/0","type":"function"},{"doc":"ACGUNacgun","ref":"Bio.Sequence.Alphabets.Rna.html#with_n/0","title":"Bio.Sequence.Alphabets.Rna.with_n/0","type":"function"},{"doc":"Interaction between Bio.Sequence objects and Bio.Restriction.Enzyme s. The primary function is digest/2 . The digest/2 function works by recursively breaking down a binary and checking to see if the pattern for a given enzyme exists within it. Redesign Incoming Initially I had thought to just get the data and apply it. Having only been familiar with quite a small sub-set of the possible digestion outcomes. That said, I did some reading and it seems that having digest/2 be type specific to the type and sub-type of the enzyme is the best approach. That means that I need to re-write the parser for the REBASE data. Which means that there's more work to be done! When is that ever not true... Anyway you probably don't want to use this until then. Missing Functionality Currently we don't support enzymes that have two cut sites, or enzymes with ambiguous DNA recognition. Missing Data The enzyme HpyUM037X is removed from the set, since it has two conflicting entries in the emboss data. If you can resolve this distinction, please feel free to either contribute a fix, or open an issue that explains how one would be implemented.","ref":"Bio.Restriction.html","title":"Bio.Restriction","type":"module"},{"doc":"Digest takes in a string, anticipated to be a DNA sequence, and extracts the components of the string as a tuple that would remain after digestion with a given restriction enzyme. Examples iex&gt; Bio.Restriction . digest ( &quot;ttagatgacgtctcgattagagt&quot; , Bio.Restriction.Enzyme . bsmbi ) [ &quot;ttagatgacgtctcg&quot; , &quot;attagagt&quot; ] Currently this will work for enzymes that look back as well: iex&gt; Bio.Restriction . digest ( &quot;ggatgcagatcagacgaggattga&quot; , Bio.Restriction.Enzyme . bsp143i ) [ &quot;ggatgc&quot; , &quot;agatcagacgaggattga&quot; ] It does not yet work on enzymes that would produce digestions with three parts such as NmeDI, nor will it work on enzymes whose recognition pattern is defined using ambiguous DNA (even simply N).","ref":"Bio.Restriction.html#digest/2","title":"Bio.Restriction.digest/2","type":"function"},{"doc":"This module houses all of the functions for accessing a struct of restriction enzyme data, the %Bio.Restriction.Enzyme . All functions are the name of the enzyme in lowercase, where any - characters have been made _ . By example, &quot;BsmBI&quot; would be bsmbi or &quot;CviKI-1&quot; would become cviki_1 .","ref":"Bio.Restriction.Enzyme.html","title":"Bio.Restriction.Enzyme","type":"module"},{"doc":"The primary struct for interacting with restriction enzymes","ref":"Bio.Restriction.Enzyme.html#__struct__/0","title":"Bio.Restriction.Enzyme.__struct__/0","type":"function"},{"doc":"Get an enzyme struct by name, where name is either a binary or atom and case insensitive. Examples iex&gt; Bio.Restriction.Enzyme . get ( :CviRI ) % Bio.Restriction.Enzyme { blunt? : true , cut_1 : 2 , cut_2 : 2 , cut_3 : 0 , cut_4 : 0 , name : &quot;CviRI&quot; , pattern : &quot;tgca&quot; } iex&gt; Bio.Restriction.Enzyme . get ( &quot;CviRI&quot; ) % Bio.Restriction.Enzyme { blunt? : true , cut_1 : 2 , cut_2 : 2 , cut_3 : 0 , cut_4 : 0 , name : &quot;CviRI&quot; , pattern : &quot;tgca&quot; }","ref":"Bio.Restriction.Enzyme.html#get/1","title":"Bio.Restriction.Enzyme.get/1","type":"function"},{"doc":"Defines behavior for modules to act as a converter between sequences. The core of this base module is to provide the default to/1 function. This will return the error tuple for undefined conversions. This alleviates the need of the user defined module to provide this implementation, and eliminates the possibility of the function to/1 raising due to no matching clauses. To use this as a base for your converter you use the module and pass a block for defining the user-side to/1 calls. For example: defmodule SomeConversion do use Bio.Convertible do def to ( SomeModule ) , do : { :ok , &amp; your_kmer_converter / 2 , 6 } defp your_kmer_converter ( { :ok , kmers , data } , module ) do # conversion logic end end end This defines the k-wise converter that will be used by Bio.Polymer.convert/3 . The function you define for the actual conversion will be given an :ok tuple with the kmers and any additional data defined for the struct that you're converting. How this data is partitioned is managed by the Bio.Polymeric definition. As an example, the Bio.Sequence.DnaStrand struct simply drops the sequence key, retaining all other keys as the data given to the fn/2 you define. This allows you to retain any relevant information for a newly created struct. If you wanted to define your own sequence, this then requires that you also implement the Bio.Polymeric interface. So if you were to implement SomeSequence , you would do the following: defmodule SomeSequence do @behaviour Bio.Sequential @impl Bio.Sequential def converter , do : SomeConversion # implementation of other callbacks end The Bio.Sequential behavior ensures that we implement the converter/0 function which is called from the Bio.Polymer module. This in turn constructs the basic converter mechanic, and now you would implement Bio.Polymeric : defimpl Bio.Polymeric , for : SomeSequence do def kmers ( seq , k ) do # your logic for splitting the polymer into k sized kmers end def valid? ( seq , alpha ) do # your logic checking if the polymer is valid end def validate ( seq , alpha ) do # your logic for validating the polymer end end Now you can simply call: SomeSequence . new ( &quot;some data&quot; ) |&gt; Bio.Polymer . convert ( SomeModule ) The Bio.Polymer.convert/3 function now handles calling your conversion method your_kmer_converter . This will be called with the kmers generated by Bio.Polymeric 's implementation of kmers/2 , which will be passed a value of k=6 , as defined in the conversion callback. This is perhaps overly complex, but here are the design goals: Allow a user to define a conversion from one type to another, regardless of if that type is internal. Allow that definition to leverage existing protocols for e.g. kmers. Allow a dead simple interface for working with internal components when extensions aren't needed. A lot of complexity was pulled in to hit these targets, and I think that the goal is achieved. A user who doesn't need their own types can simply work with the Bio.Sequence types using the Bio.Polymer interface. However, if they want to define e.g. a converter between Bio.Sequence.RnaStrand and Bio.Sequence.AminoAcid , they can simply define a module for that conversion and pass it to the Bio.Polymer.convert/3 function. The complexity only arises to the user when they need their own sequences. Hopefully they'd have appreciated the necessity of the complexity before then.","ref":"Bio.Convertible.html","title":"Bio.Convertible","type":"behaviour"},{"doc":"Defines the converter's k-wise conversion function This is called within the Bio.Polymer.convert/3 function to acquire the k-wise conversion function for sequence to another.","ref":"Bio.Convertible.html#c:to/1","title":"Bio.Convertible.to/1","type":"callback"},{"doc":"How a &quot;sequence&quot; ought to comport itself. The Bio.Sequential behaviour is used to define the expected functions exposed by &quot;sequences&quot;. In general, sequences are basically a replacement for the enumerable qualities of strings in some other languages. Because that requires defining a protocol, and that requires a struct, it makes a lot of sense to have an easy to use initializer. Thus, the new/2 method. The opts defined will depend on the type of sequence you're creating, and so the typing is left rather general here. These should be refined for any concrete implementation. Because most sequences can be transcoded into other sequences (e.g. DNA -&gt; Amino Acid), we also want to define a getter for the module that handles that conversion. This is why the converter/0 function exists. It should return a module that implements the Bio.Convertible behaviour. Together with the Bio.Polymeric protocol, the Bio.Convertible behaviour and Bio.Polymer module create a robust conversion mechanic that can be hooked into by user defined types. For further reading on that, look at the Bio.Polymer module docs. The final callback, fasta_line/1 , exists because this is a bioinformatics library. Sequences are pretty much always going to be written out to a fasta file, or some similar context. Defining this as a callback means that we can make it easier for your types to be given directly to the Bio.IO.Fasta module for writing. Eventually, I'd probably like to come up with a more general dump style mechanic. But this'll do for the pre-alpha.","ref":"Bio.Sequential.html","title":"Bio.Sequential","type":"behaviour"},{"doc":"Returns the module which implements to/1 functions for type conversion. This returns the module, which is then used from within Bio.Polymer.convert/3 to acquire the correct conversion function for a given type. Your code shouldn't need to call this. It exists to interface with the Bio.Polymer module's functions.","ref":"Bio.Sequential.html#c:converter/0","title":"Bio.Sequential.converter/0","type":"callback"},{"doc":"Given a struct, returns the String.t() line for a FASTA file This will be called from within Bio.IO.Fasta.write/3","ref":"Bio.Sequential.html#c:fasta_line/1","title":"Bio.Sequential.fasta_line/1","type":"callback"},{"doc":"Builds a new struct for the implementing type. This is provided as: A simple way to initialize various types. A place to perform pre-computations/optimizations in the future. The default implementation for example does a pre-computation of the length of the sequence, which is stored on the base type. This in turn allows the Enumerable interface to be implemented efficiently.","ref":"Bio.Sequential.html#c:new/2","title":"Bio.Sequential.new/2","type":"callback"},{"doc":"Implements a wrapper around the Enum module's public interface. The semantics of the Enum module don't always match up with what I would think is best for certain cases. The best example of this is the slide/3 function. Because of the Enum implementation, there is no way to coerce the return value back into a struct. So for example, given a Bio.Sequence.DnaStrand it would return a list of graphemes. This is not what I want users to expect. That said, there are other functions that do behave well. Or at the very least, their semantics seem meaningfully useful. So in order to preserve the maximum utility, I wrap the module. The expectation should be as follows: Enum functions will return bare data. Bio.Enum functions will return the closest thing to the struct as is reasonable. There are cases where it doesn't make much sense to return more than is required. For example, the Bio.Enum.at/2 function will return a binary grapheme. I have a hard time imagining a case where the user would want a struct with a sequence of a single character instead of the character itself. Contrast that with the Enum.at/2 function, which will return a raw char.","ref":"Bio.Enum.html","title":"Bio.Enum","type":"module"},{"doc":"","ref":"Bio.Enum.html#at/2","title":"Bio.Enum.at/2","type":"function"},{"doc":"","ref":"Bio.Enum.html#at/3","title":"Bio.Enum.at/3","type":"function"},{"doc":"","ref":"Bio.Enum.html#chunk_every/2","title":"Bio.Enum.chunk_every/2","type":"function"},{"doc":"","ref":"Bio.Enum.html#chunk_every/3","title":"Bio.Enum.chunk_every/3","type":"function"},{"doc":"","ref":"Bio.Enum.html#chunk_every/4","title":"Bio.Enum.chunk_every/4","type":"function"},{"doc":"","ref":"Bio.Enum.html#chunk_while/4","title":"Bio.Enum.chunk_while/4","type":"function"},{"doc":"","ref":"Bio.Enum.html#map/2","title":"Bio.Enum.map/2","type":"function"},{"doc":"","ref":"Bio.Enum.html#reverse/1","title":"Bio.Enum.reverse/1","type":"function"},{"doc":"","ref":"Bio.Enum.html#reverse/2","title":"Bio.Enum.reverse/2","type":"function"},{"doc":"","ref":"Bio.Enum.html#slice/2","title":"Bio.Enum.slice/2","type":"function"},{"doc":"","ref":"Bio.Enum.html#slice/3","title":"Bio.Enum.slice/3","type":"function"},{"doc":"","ref":"Bio.Enum.html#t:acc/0","title":"Bio.Enum.acc/0","type":"type"},{"doc":"","ref":"Bio.Enum.html#t:default/0","title":"Bio.Enum.default/0","type":"type"},{"doc":"","ref":"Bio.Enum.html#t:element/0","title":"Bio.Enum.element/0","type":"type"},{"doc":"","ref":"Bio.Enum.html#t:index/0","title":"Bio.Enum.index/0","type":"type"},{"doc":"","ref":"Bio.Enum.html#t:t/0","title":"Bio.Enum.t/0","type":"type"},{"doc":"Define Polymeric interface of a sequence type. The Bio.Polymeric protocol allows us to define implementations of a kmers/2 function. This is part of the approach to translating different polymers according to the nature of actual biological or chemical processes. The idea is that defining how a sequence is sub-divided into k-mers for enumeration is something that must occur for specific conversions. However, it's also something that you would not necessarily want to have to do every single time you applied the conversion. Essentially, each structural definition of a sequence will have some meaningful way of splitting it into a Kmer enumeration. This is used in all forms of computation, largely though, in conversions. For example, DNA -&gt; RNA conversions require element-wise (k=1) conversion functions. Whereas, RNA -&gt; Amino Acid requires codon-wise (k=3). In order to preserve the standard interface defined by Bio.Polymer and Bio.Polymer.convert/3 , we define this as a protocol. For a valid return, the consideration should be: The enumerable returned ( Enum.t() ) should contain the information required to perform a conversion. Examples can be found in the Bio.Sequence.DnaStrand and Bio.Sequence.DnaDoubleStrand modules. There, you'll see that for a simple sequence, it makes sense to simple iterate the grouped chunks. Whereas the double stranded sequence returns a list of tuples of chunks. The map() should contain relevant data for the re-capitulation of a struct. So if you're converting a DnaStrand , you should consider passing back out the label field. This allows the conversion function to attach it to the newly constructed type. The error mode for various sequences will vary, but generally the idea of mismatching the sequence length to the k value will hold. For the build in Bio.Sequence.DnaStrand , this is merely the even division. For the Bio.Sequence.DnaDoubleStrand it's more complicated. That type assumes that you want to see pairs of aggregated values (top/bottom), but they may be offset. So you can't just look at if the values are empty. Instead, it looks to see if there can be complete aggregates, even if they're paired with empty space. Keep these considerations in mind implementing your own Polymeric types. In addition to the enumeration of the elements, this also makes sense as the location for defining validity. That is, there are two further methods valid?/2 and validate/2 . These make the assumption that a relevant alphabet is defined for the polymer. For example, IUPAC DNA Codes . Your implementation of valid?/2 and validate/2 should prefer the alphabet given to them. This will be respected by the Bio.Polymer.valid?/2 and Bio.Polymer.validate/2 function. Essentially, when used, these will always prefer the given value, but will default back to the value attached to the type if it is defined. Example iex&gt; alias Bio.Sequence.Alphabets.Dna , as : Alpha ...&gt; Bio.Sequence.DnaStrand . new ( &quot;atgcnn&quot; , alphabet : Alpha . common ( ) ) ...&gt; |&gt; Bio.Polymer . valid? ( ) false iex&gt; alias Bio.Sequence.Alphabets.Dna , as : Alpha ...&gt; Bio.Sequence.DnaStrand . new ( &quot;atgcnn&quot; , alphabet : Alpha . common ( ) ) ...&gt; |&gt; Bio.Polymer . valid? ( Alpha . with_n ( ) ) true Note In case neither is defined, the validate/2 function will return an error tuple, where the valid? will simply return false. The validate/2 function behaves similarly, but it should return a new struct with the valid? key set. Example iex&gt; alias Bio.Sequence.Alphabets.Dna , as : Alpha ...&gt; Bio.Sequence.DnaStrand . new ( &quot;atgcnn&quot; , alphabet : Alpha . common ( ) ) ...&gt; |&gt; Bio.Polymer . validate ( ) { :error , [ { :mismatch_alpha , &quot;n&quot; , 4 } , { :mismatch_alpha , &quot;n&quot; , 5 } ] } iex&gt; alias Bio.Sequence.Alphabets.Dna , as : Alpha ...&gt; Bio.Sequence.DnaStrand . new ( &quot;atgcnn&quot; , alphabet : Alpha . common ( ) ) ...&gt; |&gt; Bio.Polymer . validate ( Alpha . with_n ( ) ) { :ok , % Bio.Sequence.DnaStrand { sequence : &quot;atgcnn&quot; , length : 6 , alphabet : &quot;ACGTNacgtn&quot; , valid? : true } } Note The applied alphabet is the one that is returned in the struct. This ensures that you are correctly tracking what a type is valid for . So be careful about assumptions.","ref":"Bio.Polymeric.html","title":"Bio.Polymeric","type":"protocol"},{"doc":"Split a polymer into chunks of k size","ref":"Bio.Polymeric.html#kmers/2","title":"Bio.Polymeric.kmers/2","type":"function"},{"doc":"Determine if the content of a polymer matches an alphabet","ref":"Bio.Polymeric.html#valid?/2","title":"Bio.Polymeric.valid?/2","type":"function"},{"doc":"Validate if the content of a polymer matches an alphabet, returning an updated struct. Depends on the struct implementing both an alphabet and valid? keys.","ref":"Bio.Polymeric.html#validate/2","title":"Bio.Polymeric.validate/2","type":"function"},{"doc":"","ref":"Bio.Polymeric.html#t:t/0","title":"Bio.Polymeric.t/0","type":"type"},{"doc":"Internal helper module for dealing with amino acids","ref":"Bio.AcidHelper.html","title":"Bio.AcidHelper","type":"module"},{"doc":"","ref":"Bio.AcidHelper.html#t:alphabet/0","title":"Bio.AcidHelper.alphabet/0","type":"type"},{"doc":"","ref":"Bio.AcidHelper.html#t:character/0","title":"Bio.AcidHelper.character/0","type":"type"},{"doc":"","ref":"Bio.AcidHelper.html#t:index/0","title":"Bio.AcidHelper.index/0","type":"type"},{"doc":"","ref":"Bio.AcidHelper.html#t:mismatch/0","title":"Bio.AcidHelper.mismatch/0","type":"type"},{"doc":"","ref":"use_xml_and_xpath.html","title":"How To Work With XML","type":"extras"},{"doc":"This is an overview of how to use XPaths to query an XML structure in Elixir.","ref":"use_xml_and_xpath.html#document-purpose","title":"How To Work With XML - Document Purpose","type":"extras"},{"doc":"I'm a software engineer. Plain and simple. I do not know what you want, nor do I have a desire to lock you into a specific sub-set of the data that can be retrieved from any given format. This is no exception. My primary goal in this project is to provide powerful, efficient, and expressive tooling, which will allow more intuitive tooling in higher level projects.","ref":"use_xml_and_xpath.html#why-force-you-to-deal-with-xpath","title":"How To Work With XML - Why force you to deal with XPath?","type":"extras"},{"doc":"Wikipedia's definition of XML is fairly useful here: Extensible Markup Language (XML) is a markup language and file format for storing, transmitting, and reconstructing arbitrary data. It defines a set of rules for encoding documents in a format that is both human-readable and machine-readable. The World Wide Web Consortium's XML 1.0 Specification of 1998 and several other related specifications—all of them free open standards—define XML. That is, XML is a structured document format. This allows us to treat the document according the Document Object Model (DOM). This will be familiar to anyone with experience in developing for the web, as HTML is a similar format. In fact, you can use XPath to query HTML documents in JavaScript as well. The most basic form of access is the root. All well formed documents will have a root node against which you can query. This will often take the form of the / character. This is a very common idiom for tree-like structures, not limited to the DOM. Even the root directory of your file-system (on *nix) will be represented as such. Each element beyond the root is considered as a child. You can access them with /ChildNode . For those familiar with HTML, the biggest difference between XML and HTML is that there isn't a standard for the nodes. In XML, each node can be defined however you would like. So this is a perfectly valid document: &lt;?xml version=&quot;1.0&quot; ?&gt; &lt;OuterBody&gt; &lt;InnerBody&gt; &lt;InnerField1&gt;Content&lt;/InnerField1&gt; &lt;InnerField2&gt;Content&lt;/InnerField2&gt; &lt;InnerField3&gt;Content&lt;/InnerField3&gt; &lt;/InnerBody&gt; &lt;OuterField1&gt;Content&lt;/OuterField1&gt; &lt;OuterField2&gt;Content&lt;/OuterField2&gt; &lt;/OuterBody&gt; Where the root node is /OuterBody , and the children are OuterBody/InnerBody , OuterBody/OuterField1 , and OuterBody/OuterField2 . The fields do not need to be numbered though, and more often they won't be. Something more common might be: &lt;?xml version=&quot;1.0&quot; ?&gt; &lt;OuterBody&gt; &lt;InnerBody&gt; &lt;InnerField&gt;Content&lt;/InnerField&gt; &lt;InnerField&gt;Content&lt;/InnerField&gt; &lt;InnerField&gt;Content&lt;/InnerField&gt; &lt;/InnerBody&gt; &lt;OuterField&gt;Content&lt;/OuterField&gt; &lt;OuterField&gt;Content&lt;/OuterField&gt; &lt;/OuterBody&gt; The fields will normally be named according to the semantic meaning of the contents. You can also have various attributes that are associated with each node: &lt;?xml version=&quot;1.0&quot; ?&gt; &lt;OuterBody&gt; &lt;InnerBody name=&quot;First Inner&quot;&gt; &lt;InnerField&gt;Content&lt;/InnerField&gt; &lt;InnerField&gt;Content&lt;/InnerField&gt; &lt;InnerField&gt;Content&lt;/InnerField&gt; &lt;/InnerBody&gt; &lt;OuterField&gt;Content&lt;/OuterField&gt; &lt;OuterField&gt;Content&lt;/OuterField&gt; &lt;/OuterBody&gt; This is useful for when you are representing hierarchical relationships. These are access by using the @&lt;field_attribute&gt; notation. So the above would be /Outerbody/InnerBody/@name .","ref":"use_xml_and_xpath.html#xpath-basics","title":"How To Work With XML - XPath Basics","type":"extras"},{"doc":"Querying paths with Erlang is very straightforward. The biggest issue with doing so is that you will need to convert between binaries and character lists. As this interface is elixir, the expectation is character list. :xmerl_xpath . string ( &#39;/path/to/node&#39; , xml_doc ) Let's use an example that is a little easier to think about, something like research paper citations: &lt;?xml version=&quot;1.0&quot; ?&gt; &lt;References&gt; &lt;Paper refNum=&quot;1&quot;&gt; &lt;Title&gt;A Novel Method for Quantification of Midi-Chlorians From Salivary Samples&lt;/Title&gt; &lt;Authors&gt; &lt;Author name=&quot;H. Solo&quot;&gt;&lt;/Author&gt; &lt;Author name=&quot;L. Organa&quot;&gt;&lt;/Author&gt; &lt;Author name=&quot;L. Skywalker&quot;&gt;&lt;/Author&gt; &lt;/Authors&gt; &lt;/Paper&gt; &lt;Paper refNum=&quot;2&quot;&gt; &lt;Title&gt;Harmonic Crystal Frequencies and Light-Saber Characteristics: Review&lt;/Title&gt; &lt;Authors&gt; &lt;Author name=&quot;A. Skywalker&quot;&gt;&lt;/Author&gt; &lt;Author name=&quot;O. Kenobi&quot;&gt;&lt;/Author&gt; &lt;Author name=&quot;A. Tano&quot;&gt;&lt;/Author&gt; &lt;/Authors&gt; &lt;/Paper&gt; &lt;Paper refNum=&quot;3&quot;&gt; &lt;Title&gt;Modification of the Natural Foci for Midi-Chlorian Energies&lt;/Title&gt; &lt;Authors&gt; &lt;Author name=&quot;D. Plagueis&quot;&gt;&lt;/Author&gt; &lt;Author name=&quot;D. Sidious&quot; aka=&quot;S. Palpatine&quot;&gt;&lt;/Author&gt; &lt;Author name=&quot;D. Maul&quot;&gt;&lt;/Author&gt; &lt;Author name=&quot;D. Vader&quot; aka=&quot;A. Skywalker&quot;&gt;&lt;/Author&gt; &lt;/Authors&gt; &lt;/Paper&gt; &lt;/References&gt; Note : I had to look up a lot of names and general themes on Wookipedia. I hope that you can enjoy the references for what they are. I tried. There are obviously different ways that you might want to query this data. For example, let's say that you wanted to get the paper with refNum=&quot;2&quot; . I'll start by showing how to parse the file, assuming you call it something like practice.xml { xml , _rest } = :xmerl_scan . file ( &#39;practice.xml&#39; ) Demonstrating again that when interacting with the Erlang libraries, you should recall to use character lists not binaries. That said, if you do use a binary here it won't actually fail. Now to perform the query: :xmerl_xpath . string ( &#39;/*/Paper[@refNum=&quot;2&quot;]&#39; , xml ) This will net you back the slightly massive looking: [ { :xmlElement , :Paper , :Paper , [ ] , { :xmlNamespace , [ ] , [ ] } , [ References : 1 ] , 4 , [ { :xmlAttribute , :refNum , [ ] , [ ] , [ ] , [ Paper : 4 , References : 1 ] , 1 , [ ] , &#39;2&#39; , false } ] , [ { :xmlText , [ Paper : 4 , References : 1 ] , 1 , [ ] , &#39; \\n &#39; , :text } , { :xmlElement , :Title , :Title , [ ] , { :xmlNamespace , [ ] , [ ] } , [ Paper : 4 , References : 1 ] , 2 , [ ] , [ { :xmlText , [ Title : 2 , Paper : 4 , References : 1 ] , 1 , [ ] , &#39;Harmonic Crystal Frequencies and Light-Saber Characteristics: Review&#39; , :text } ] , [ ] , &quot;.&quot; , :undeclared } , { :xmlText , [ Paper : 4 , References : 1 ] , 3 , [ ] , &#39; \\n &#39; , :text } , { :xmlElement , :Authors , :Authors , [ ] , { :xmlNamespace , [ ] , [ ] } , [ Paper : 4 , References : 1 ] , 4 , [ ] , [ { :xmlText , [ Authors : 4 , Paper : 4 , References : 1 ] , 1 , [ ] , &#39; \\n &#39; , :text } , { :xmlElement , :Author , :Author , [ ] , { :xmlNamespace , [ ] , [ ] } , [ Authors : 4 , Paper : 4 , References : 1 ] , 2 , [ { :xmlAttribute , :name , [ ] , [ ] , [ ] , [ Author : 2 , Authors : 4 , Paper : 4 , References : 1 ] , 1 , [ ] , &#39;A. Skywalker&#39; , false } ] , [ ] , [ ] , &quot;.&quot; , :undeclared } , { :xmlText , [ Authors : 4 , Paper : 4 , References : 1 ] , 3 , [ ] , &#39; \\n &#39; , :text } , { :xmlElement , :Author , :Author , [ ] , { :xmlNamespace , [ ] , [ ] } , [ Authors : 4 , Paper : 4 , References : 1 ] , 4 , [ { :xmlAttribute , :name , [ ] , [ ] , [ ] , [ Author : 4 , Authors : 4 , Paper : 4 , References : 1 ] , 1 , [ ] , &#39;O. Kenobi&#39; , false } ] , [ ] , [ ] , &quot;.&quot; , :undeclared } , { :xmlText , [ Authors : 4 , Paper : 4 , References : 1 ] , 5 , [ ] , &#39; \\n &#39; , :text } , { :xmlElement , :Author , :Author , [ ] , { :xmlNamespace , [ ] , [ ] } , [ Authors : 4 , Paper : 4 , References : 1 ] , 6 , [ { :xmlAttribute , :name , [ ] , [ ] , [ ] , [ Author : 6 , Authors : 4 , Paper : 4 , References : 1 ] , 1 , [ ] , &#39;A. Tano&#39; , false } ] , [ ] , [ ] , &quot;.&quot; , :undeclared } , { :xmlText , [ Authors : 4 , Paper : 4 , References : 1 ] , 7 , [ ] , &#39; \\n &#39; , :text } ] , [ ] , &quot;.&quot; , :undeclared } , { :xmlText , [ Paper : 4 , References : 1 ] , 5 , [ ] , &#39; \\n &#39; , :text } ] , [ ] , &quot;.&quot; , :undeclared } ] This is a slightly intimidating wall of data. Within it, you can see the pieces that matter to you. We have the title of the paper, as well as the authors. This is a good start, but what if you want a list of just the names of the authors? :xmerl_xpath . string ( &#39;/*/Paper[@refNum=&quot;2&quot;]/Authors/Author&#39; , xml ) This will get you the tags. To be fair, you can just index into the tuples to get the values you want. But that's probably a little brittle. What makes more sense is to use the string() function in the XPath: :xmerl_xpath . string ( &#39;string(/*/Paper[@refNum=&quot;2&quot;]/Authors/Author/@name)&#39; , xml ) But if you try this, you only get back one name. We can combine some of what we've learned though to enumerate and get the names back easily: :xmerl_xpath . string ( &#39;/*/Paper[@refNum=&quot;2&quot;]/Authors/Author/@name&#39; , xml ) |&gt; Enum . map ( fn el -&gt; :xmerl_xpath . string ( &#39;string(/*)&#39; , el ) end ) Which gives us: [ { :xmlObj , :string , &#39;A. Skywalker&#39; } , { :xmlObj , :string , &#39;O. Kenobi&#39; } , { :xmlObj , :string , &#39;A. Tano&#39; } ] This works because we get the exact node that we want, then we iterate over the group and simply apply the string function to that node. Using /* is necessary because the node is now technically the root. This allows us to avoid needing to use indices to access items. Another common operation you might like to perform is to find something conditionally. For example, all the papers that were authored by a specific individual. This is somewhat trickier: :xmerl_xpath . string ( &#39;string(/*/Paper[descendant::Authors/Author[@name=&quot;L. Skywalker&quot;]]/Title)&#39; , xml ) Here we're using the conditional selection Node[criterion] . This would allow us to select e.g. all the nodes with a specific property. Then we use the descendant:: qualifier to define the criterion as being on the children of the paper. Calling string on the title merely retrieves the desired datum. For a more complex condition, let's say that we want to select all the papers that were authored by A. Skywalker, either in name or in aka: condition_1 = &#39;/*/Paper[descendant::Authors/Author[@name=&quot;A. Skywalker&quot;]]/Title&#39; condition_2 = &#39;/*/Paper[descendant::Authors/Author[@aka=&quot;A. Skywalker&quot;]]/Title&#39; :xmerl_xpath . string ( &#39; \#{ condition_1 } | \#{ condition_2 } &#39; , xml ) This can again be used with the mapping and string selection to get the titles in a friendlier to access format, ala: :xmerl_xpath . string ( &#39; \#{ condition_1 } | \#{ condition_2 } &#39; , xml ) |&gt; Enum . map ( fn el -&gt; :xmerl_xpath . string ( &#39;string(/*)&#39; , el ) end ) Conclusion This is a really quick survey of the experimentation that I did to get some useful XPath queries written. Hopefully these are helpful to you in dealing with any XML that is returned. If you find that you want to do something and need a reference, then I can recommend the specification for XPath. It's a little dense, but you should be able to use the reference to come up with anything that can be done. References https://en.wikipedia.org/wiki/XML#Pull_parsing https://www.w3.org/TR/2008/REC-xml-20081126 https://www.erlang.org/doc/man/xmerl https://starwars.fandom.com/wiki/Main_Page https://www.w3.org/TR/2017/REC-xpath-31-20170321/","ref":"use_xml_and_xpath.html#querying-paths-with-erlang","title":"How To Work With XML - Querying Paths with Erlang","type":"extras"}]